#include "generalized.h"

/*
 * generalized.c
 *
 * this file contains generalized functions of use in various parts of
 * mdebs.
 */

/*
 * acctQuery()
 *
 * Given an account number, returns 1 if the account exists, 0 otherwise.
 * Bails out on error.
 */
char *acctQuery(char *nam, char *acct, char *anal)
{
  char miscbuff[81];
  int resultcode, noofrecs;
  
  sprintf(miscbuff, "SELECT * FROM osnova WHERE acct='%s' and anal='%s';", acct, anal);
  resultcode = runQuery(miscbuff);
  if (resultcode == 3) {                /* this is the proper result code */
    noofrecs = numberReturned();
    if (noofrecs > 1) {
      fprintf(stderr, "Error: Corrupted database: Account number must be unique.\n");
      exit_nicely();
    }
  } else {
    fprintf(stderr, "Fatal Error: Query returned improper result code (%d).\n", resultcode);
    exit_nicely();
  }
  if (noofrecs == 0) return NULL;
  else {
    return (nam = getField("desig"));
  }
}

/*
 * NathanConvertDate()
 *
 * This function converts dates from a 'mm-dd-yyyy' character string to
 * an yyyymmdd integer.
 *
 * This is a "garbage in, garbage out" function.
 */
int NathanConvertDate(char *pgdate)
{
  short year, month, day;
  char buf[4];

  buf[0] = *pgdate;
  buf[1] = *(pgdate + 1);
  buf[2] = '\0';
  month = atoi(buf);
  
  buf[0] = *(pgdate + 3);
  buf[1] = *(pgdate + 4);
  buf[2] = '\0';
  day = atoi(buf);

  buf[0] = *(pgdate + 6);
  buf[1] = *(pgdate + 7);
  buf[2] = *(pgdate + 8);
  buf[3] = *(pgdate + 9);
  buf[4] = '\0';
  year = atoi(buf);

  return ((year*10000)+(month*100)+day);
}

/*
 * pgConvertDate()
 *
 * This function is the reverse of the NathanConvertDate()
 * function. It converts dates from a yyyymmdd integer to a
 * 'mm-dd-yyyy' character string.
 *
 * This is a "garbage in, garbage out" function.  
 */
char *pgConvertDate(char *pgdate, int nathandate)
{
  short year, month, day;

  year = nathandate / 10000;
  nathandate = nathandate - (year*10000);
  month = nathandate / 100;
  nathandate = nathandate - (month*100);
  day = nathandate;

  sprintf(pgdate, "%02d-%02d-%4d", month, day, year);
  *(pgdate+11) = '\0';
  return pgdate;
}



